import { type MatchResult, type MatchModel } from 'js-match-words';
export interface HighlightData {
    activeClassName: string;
    activeStyle: string;
    activeIndex: number;
    className: string;
    highlightClassName: string;
    highlightStyle: string;
    highlightTag: string;
}
export interface HighlightConfig {
    [prop: string | number]: HighlightData;
}
export interface HighlightOptions {
    source: string;
    searchWords: string[];
    config: HighlightConfig;
}
export declare function generate(matchResult: MatchResult, config: HighlightConfig): string;
export declare function createHtml(val: MatchModel, config: HighlightConfig): string;
export declare function highlight(options: HighlightOptions): string;
