/**
* libs v7.0.9 by sunsilent
* @license MIT
**/
/*! For license information please see index.js.LICENSE.txt */
(function(root, factory) {
    if ('object' == typeof exports && 'object' == typeof module) module.exports = factory();
    else if ('function' == typeof define && define.amd) define([], factory);
    else if ('object' == typeof exports) exports["HighlightWords"] = factory();
    else root["HighlightWords"] = factory();
})(self, function() {
    return function() {
        "use strict";
        var __webpack_require__ = {};
        !function() {
            __webpack_require__.d = function(exports1, definition) {
                for(var key in definition)if (__webpack_require__.o(definition, key) && !__webpack_require__.o(exports1, key)) Object.defineProperty(exports1, key, {
                    enumerable: true,
                    get: definition[key]
                });
            };
        }();
        !function() {
            __webpack_require__.o = function(obj, prop) {
                return Object.prototype.hasOwnProperty.call(obj, prop);
            };
        }();
        !function() {
            __webpack_require__.r = function(exports1) {
                if ('undefined' != typeof Symbol && Symbol.toStringTag) Object.defineProperty(exports1, Symbol.toStringTag, {
                    value: 'Module'
                });
                Object.defineProperty(exports1, '__esModule', {
                    value: true
                });
            };
        }();
        var __webpack_exports__ = {};
        __webpack_require__.r(__webpack_exports__);
        __webpack_require__.d(__webpack_exports__, {
            createHtml: function() {
                return createHtml;
            },
            generate: function() {
                return generate;
            },
            highlight: function() {
                return highlight;
            }
        });
        /**
* libs v7.0.4 by sunsilent
* @license MIT
**/ function matchWords(options) {
            const { source, searchWords, caseSensitive } = options;
            if ('string' != typeof source) throw new Error(`${source} is not string type.`);
            const regexp = new RegExp(searchWords.map((e)=>`(${e})`).join('|'), caseSensitive ? 'g' : 'gi');
            const r = source.matchAll(regexp);
            const words = [];
            let d = r.next();
            while(!d.done){
                const start = d.value.index;
                const end = start + d.value[0].length;
                if (words.length) {
                    if (words[words.length - 1].end !== start) words.push({
                        start: words[words.length - 1].end,
                        end: start,
                        highlight: false,
                        value: source.substring(words[words.length - 1].end, start)
                    });
                    else words.push({
                        start,
                        end,
                        highlight: false,
                        value: source.substring(start, end)
                    });
                } else {
                    if (0 !== start) words.push({
                        start: 0,
                        end: start,
                        highlight: false,
                        value: source.substring(0, start),
                        index: 0
                    });
                    words.push({
                        start,
                        end,
                        highlight: true,
                        value: d.value[0]
                    });
                }
                updateIndex(words);
                d = r.next();
            }
            if (words.length) {
                if (words[words.length - 1].end !== source.length - 1) {
                    const start = words[words.length - 1].end;
                    const end = words[words.length - 1].end + source.length - 1;
                    words.push({
                        start,
                        end,
                        highlight: false,
                        value: source.substring(start, source.length)
                    });
                }
            }
            return {
                values: words,
                searchWords
            };
        }
        function updateIndex(words) {
            let count = 0;
            const value = words[words.length - 1].value;
            words.forEach((e)=>{
                if (e.value === value) count += 1;
            });
            words[words.length - 1].index = count > 0 ? count - 1 : 0;
        }
        function generate(matchResult, config) {
            var values = matchResult.values;
            var res = '';
            values.forEach(function(val) {
                res += createHtml(val, config);
            });
            return res;
        }
        function createHtml(val, config) {
            var options = config[val.value];
            var _ref = options || {}, activeClassName = _ref.activeClassName, activeStyle = _ref.activeStyle, activeIndex = _ref.activeIndex, className = _ref.className, highlightClassName = _ref.highlightClassName, highlightStyle = _ref.highlightStyle, highlightTag = _ref.highlightTag;
            var cls = "".concat(className || '', " ").concat(highlightClassName || '', " ").concat(val.index === activeIndex ? activeClassName || '' : '');
            var style = "".concat(highlightStyle || '', " ").concat(val.index === activeIndex ? activeStyle || '' : '');
            if (!highlightTag) return val.value;
            return "<".concat(highlightTag, ' class="').concat(cls, '" style="').concat(style, '">').concat(val.value, "</").concat(highlightTag, ">");
        }
        function highlight(options) {
            var source = options.source, searchWords = options.searchWords, config = options.config;
            return generate(matchWords({
                source: source,
                searchWords: searchWords
            }), config);
        }
        return __webpack_exports__;
    }();
});
